#ifndef BASISMATRIX_H
#define BASISMATRIX_H

#include <stdio.h>
#include "Point.h"
#include "Ribabble.h"

/* This is implements a basic */
/* cubic-spline patch. */
class BasisMatrix: public Ribabble {

  public:
    BasisMatrix( void );
    BasisMatrix(
        double b00, double b01, double b02, double b03,
        double b10, double b11, double b12, double b13,
        double b20, double b21, double b22, double b23,
        double b30, double b31, double b32, double b33,
        char* text
    );

    void m( int i, int j, double d );
    double m( int i, int j );

    void text( char* text ); 
    char* text( void ); 

    void rib( FILE* fd );

/*private:*/
    double m_[4][4];
    char* text_;
};

extern BasisMatrix * catmull_rom;
extern BasisMatrix * bspline;
extern BasisMatrix * bezier;

void BasisMatrix_init( void );

#endif /* BASISMATRIX_H */
