
#include <assert.h>
#include <malloc.h>
#include "CubicPatchList.h"

CubicPatchList::CubicPatchList( void ) {
    physicalLength_ = 4;
    logicalLength_  = 0;
    array_          = (CubicPatch**) malloc( physicalLength_ * sizeof( CubicPatch*) );
    array_[0]       = 0;
}

 void
CubicPatchList::add( CubicPatch* p ) {
    // Don't insert the same one twice:
    int i;
    for (i = logicalLength_;   i --> 0; )  if (array_[i] == p)   return;

    if (logicalLength_ == physicalLength_) {
        array_          = (CubicPatch**) realloc( array_, 2 * physicalLength_ * sizeof( CubicPatch*) );
        assert( array_ );
        physicalLength_ *= 2;
    }
    array_[ logicalLength_ ++ ] = p;
}

 CubicPatch*
CubicPatchList::first( void ) {
    return array_[0];
}

 CubicPatch*
CubicPatchList::next( CubicPatch* p ) {
    int i;
    for (i = 0;   i < logicalLength_-1;   ++i)  if (array_[i] == p)   return array_[i+1];
    return 0;
}

 CubicPatch*
CubicPatchList::nth( int i ) {
    assert (i >= 0 && i < logicalLength_);
    return array_[i];
}

 int
CubicPatchList::length( void ) {
    return logicalLength_;
}

