#ifndef CUBICSPLINE_H
#define CUBICSPLINE_H

#include "Point.h"
#include "BasisMatrix.h"

/* This is implements a basic */
/* cubic-spline patch. */
class CubicSpline {

  public:
    explicit CubicSpline( void ) {}
    explicit CubicSpline(
        BasisMatrix*b,
        Point* p0,
        Point* p1,
        Point* p2,
        Point* p3
      ): m_(b) {
        c_[0]=p0;
        c_[1]=p1;
        c_[2]=p2;
        c_[3]=p3;
    }

    void controlPoint( int i, Point* p );
    Point* controlPoint( int i );

    void basisMatrix( BasisMatrix * basisMatrix );
    BasisMatrix* basisMatrix( void );

    Xyzw value( double t );

  private:
    BasisMatrix* m_;
    Point* c_[4]; /* Control points */
};

#endif /* CUBICSPLINE_H */
