#ifndef GLOBFACTORY_H
#define GLOBFACTORY_H

#include "Point.h"
#include "BasisMatrix.h"
#include "PatchSurface.h"
#include "Vary.h"

class GlobFactory {

  public:
    GlobFactory::GlobFactory( void );
    GlobFactory::GlobFactory( Shader* );

    BasisMatrix* basisMatrix( void );
    void basisMatrix( BasisMatrix* );

    Shader* shader( void );
    void shader( Shader* );

    PatchSurface* glob(
        Surface* core,
        int inum,
        int jnum,
        double thickness,
        Vary*  vary,
        char*  name
    );

  private:
    BasisMatrix*     basisMatrix_;
    Shader*          shader_;
};

#endif /* GLOBFACTORY_H */
