#include <stdio.h>
#include <assert.h>
#include "lookup8.h"

#include "Hash.h"

Hash* hash = 0;

 void
Hash_init( void ) {
    hash = new Hash;
}

double Hash::to_0_1( double d                       )                       { return this->to_0_1( d, 0.0, 0.0, 0.0, 0.0, 0.0 ); }
double Hash::to_0_1( double d, double d2            )                       { return this->to_0_1( d, d2,  0.0, 0.0, 0.0, 0.0 ); }
double Hash::to_0_1( double d, double d2, double d3 )                       { return this->to_0_1( d, d2,  d3,  0.0, 0.0, 0.0 ); }
double Hash::to_0_1( double d, double d2, double d3, double d4 )            { return this->to_0_1( d, d2,  d3,  d4,  0.0, 0.0 ); }
double Hash::to_0_1( double d, double d2, double d3, double d4, double d5 ) { return this->to_0_1( d, d2,  d3,  d4,  d5,  0.0 ); }

 double
Hash::to_0_1(
    double d1,
    double d2,
    double d3,
    double d4,
    double d5,
    double d6
) {
    unsigned long long top = this->toUnt( d1, d2, d3, d4, d5, d6 );
    unsigned long long bot = ~(unsigned long long)0;
    double result = (double)top / (double) bot;
    return result;
}

unsigned long long Hash::toUnt( double d ) {                                             return this->toUnt( d, 0.0, 0.0, 0.0, 0.0, 0.0 ); }
unsigned long long Hash::toUnt( double d, double d2 ) {                                  return this->toUnt( d, d2,  0.0, 0.0, 0.0, 0.0 ); }
unsigned long long Hash::toUnt( double d, double d2, double d3 ) {                       return this->toUnt( d, d2,  d3 , 0.0, 0.0, 0.0 ); }
unsigned long long Hash::toUnt( double d, double d2, double d3, double d4 )            { return this->toUnt( d, d2,  d3 , d4 , 0.0, 0.0 ); }
unsigned long long Hash::toUnt( double d, double d2, double d3, double d4, double d5 ) { return this->toUnt( d, d2,  d3 , d4 , d5,  0.0 ); }

 unsigned long long
Hash::toUnt(
    double d1,
    double d2,
    double d3,
    double d4,
    double d5,
    double d6
) {
    assert( sizeof( double ) == sizeof( unsigned long long ) );
    assert( sizeof( double ) == 8 );
    union {
        unsigned char   c[ 8 ];
        double d;
        unsigned long long u;
    } a[ 6 ];

    a[0].d = d1;
    a[1].d = d2;
    a[2].d = d3;
    a[3].d = d4;
    a[4].d = d5;
    a[5].d = d6;

    return hash1( &a[0].c[0], 6*sizeof(unsigned long long), (unsigned long long)0  );
}

 // Return a double equally distributed
 // over [0.0, 1.1]: 
 double
Hash::to_0_1( const char* text ) {
    return this->to_0_1( text, "" );
}

 double
Hash::to_0_1(
    const char* string1,
    const char* string2
) {
    unsigned long long top = this->toUnt( string1, string2 );
    unsigned long long bot = ~(unsigned long long)0;
    double result = (double)top / (double) bot;
    return result;
}

 unsigned long long
Hash::toUnt(  const char* text ) {
    return this->toUnt( text, "" );
}

 unsigned long long
Hash::toUnt(
    const char* string1,
    const char* string2
) {
    unsigned int len1 = strlen( string1 );
    unsigned int len2 = strlen( string2 );

    unsigned long long buf[ 1024 ];

    assert( len1 + len2 < 1024 * sizeof( unsigned long long ) );

    strcpy( ((char*)buf)+ 0x0, string1 );
    strcpy( ((char*)buf)+len1, string2 );

    unsigned long long len = len1 + len2;

    return hash1( (unsigned char*) buf, len, 0  );
}

 signed long long
Hash::toInt(  const char* text ) {
    return (signed long long) this->toUnt( text, "" );
};

 signed long long
Hash::toInt(  const char* text, const char* text2 ) {
    return (signed long long) this->toUnt( text, text2 );
};

