#ifndef HASH_H
#define HASH_H

#include "Point.h"
#include "BasisMatrix.h"

/* This class has no state, it just      */
/* provides hashes between various kinds */
/* of values, driven by Bob Jenkins      */
/* excellent lookup8 package.  Since it  */
/* is stateless, we publish a global     */
/* instance of it via our 'hash' var:    */
class Hash {

  public:
    unsigned long long toUnt( double d1 );
    unsigned long long toUnt( double d1, double d2 );
    unsigned long long toUnt( double d1, double d2, double d3 );
    unsigned long long toUnt( double d1, double d2, double d3, double d4 );
    unsigned long long toUnt( double d1, double d2, double d3, double d4, double d5  );
    unsigned long long toUnt( double d1, double d2, double d3, double d4, double d5, double d6 );

    double             to_0_1( double d1 );
    double             to_0_1( double d1, double d2 );
    double             to_0_1( double d1, double d2, double d3 );
    double             to_0_1( double d1, double d2, double d3, double d4 );
    double             to_0_1( double d1, double d2, double d3, double d4, double d5 );
    double             to_0_1( double d1, double d2, double d3, double d4, double d5, double d6 );

    double             to_0_1( const char* text );
    double             to_0_1( const char* text, const char* text2 );

    unsigned long long toUnt(  const char* text );
    unsigned long long toUnt(  const char* text, const char* text2 );

    signed long long   toInt(  const char* text );
    signed long long   toInt(  const char* text, const char* text2 );
};

extern Hash* hash;
extern void Hash_init( void );

#endif /* HASH_H */
