#ifndef MATRIX44_H
#define MATRIX44_H

#include "Xyzw.h"

// Your vanilla 4x4 homogeneous transform matrix:
class Matrix44 {
  public:
    explicit Matrix44( void ) { this->identity(); }
    virtual Xyzw const xyzw( Xyzw in ) const;

    Matrix44 const scale(     double s ) const;
    Matrix44 const xRotate(   double r ) const;
    Matrix44 const yRotate(   double r ) const;
    Matrix44 const zRotate(   double r ) const;
    Matrix44 const translate( double x, double y, double z ) const;

    Matrix44 const scale(     Xyzw about, double s ) const;
    Matrix44 const xRotate(   Xyzw about, double r ) const;
    Matrix44 const yRotate(   Xyzw about, double r ) const;
    Matrix44 const zRotate(   Xyzw about, double r ) const;

    // Matrix multiply:
    Matrix44 const operator *( const Matrix44 ) const;
    Xyzw const    operator *( const Xyzw ) const;

  private:
    explicit Matrix44(
        double m00, double m01, double m02, double m03,
        double m10, double m11, double m12, double m13,
        double m20, double m21, double m22, double m23,
        double m30, double m31, double m32, double m33
    ) {
        m_[0][0] = m00;   m_[0][1] = m01;   m_[0][2] = m02;   m_[0][3] = m03;
        m_[1][0] = m10;   m_[1][1] = m11;   m_[1][2] = m12;   m_[1][3] = m13;
        m_[2][0] = m20;   m_[2][1] = m21;   m_[2][2] = m22;   m_[2][3] = m23;
        m_[3][0] = m30;   m_[3][1] = m31;   m_[3][2] = m32;   m_[3][3] = m33;
    }
    void identity( void );
    double m_[4][4];
};

#endif /* MATRIX44_H */
