
#include <assert.h>
#include <malloc.h>
#include "PatchSurfaceList.h"

PatchSurfaceList::PatchSurfaceList( void ) {
    physicalLength_ = 4;
    logicalLength_  = 0;
    array_          = (PatchSurface**) malloc( physicalLength_ * sizeof( PatchSurface*) );
    array_[0]       = 0;
}

 void
PatchSurfaceList::add( PatchSurface* p ) {
    // Don't insert the same one twice:
    int i;
    for (i = logicalLength_;   i --> 0; )  if (array_[i] == p)   return;

    if (logicalLength_ == physicalLength_) {
        array_          = (PatchSurface**) realloc( array_, 2 * physicalLength_ * sizeof( PatchSurface*) );
        assert( array_ );
        physicalLength_ *= 2;
    }
    array_[ logicalLength_ ++ ] = p;
}

 PatchSurface*
PatchSurfaceList::first( void ) {
    return array_[0];
}

 PatchSurface*
PatchSurfaceList::next( PatchSurface* p ) {
    int i;
    for (i = 0;   i < logicalLength_-1;   ++i)  if (array_[i] == p)   return array_[i+1];
    return 0;
}

 PatchSurface*
PatchSurfaceList::nth( int i ) {
    assert (i >= 0 && i < logicalLength_);
    return array_[i];
}

 int
PatchSurfaceList::length( void ) {
    return logicalLength_;
}

