#ifndef POINT_H
#define POINT_H

#include "Xyzw.h"

/* This is our abstract interface for */
/* anything representing a point in   */
/* vanilla 3D space.                  */
/*                                    */
/* By using homogeneous coords        */
/*    x,y,z,w                         */
/* everywhere (equivalent to the      */
/* vanilla coord x/w, y/w, z/w)       */
/*                                    */
/* we get a clean representation of   */
/* points at infinity when desired    */
/* without having the extra coding    */
/* of two types of xyz coordinates:   */
class Point {
  public:
    virtual Xyzw value() = 0;
    virtual void saveState( FILE* fd, char* title ) = 0;
    virtual void loadState( FILE* fd, char* title ) = 0;
};

#endif /* POINT_H */
