
#include <assert.h>
#include <malloc.h>
#include "PointList.h"

PointList::PointList( void ) {
    physicalLength_ = 4;
    logicalLength_  = 0;
    array_          = (Point**) malloc( physicalLength_ * sizeof( Point*) );
    array_[0]       = 0;
}

 void
PointList::add( Point* p ) {
    // Don't insert the same one twice:
    int i;
    for (i = logicalLength_;   i --> 0; )  if (array_[i] == p)   return;

    if (logicalLength_ == physicalLength_) {
        array_          = (Point**) realloc( array_, 2 * physicalLength_ * sizeof( Point*) );
        assert( array_ );
        physicalLength_ *= 2;
    }
    array_[ logicalLength_ ++ ] = p;
}

 Point*
PointList::first( void ) {
    return array_[0];
}

 Point*
PointList::next( Point* p ) {
    int i;
    for (i = 0;   i < logicalLength_-1;   ++i)  if (array_[i] == p)   return array_[i+1];
    return 0;
}

 Point*
PointList::nth( int i ) {
    assert (i >= 0 && i < logicalLength_);
    return array_[i];
}

 int
PointList::length( void ) {
    return logicalLength_;
}

