#ifndef RANDOMSTREAM_H
#define RANDOMSTREAM_H

#include <stdlib.h>
#include "glob.h"
#include "Hash.h"

class RandomStream {

  public:
    explicit RandomStream( void ) {
        xsubi_[0] = 0;
        xsubi_[1] = 0;
        xsubi_[2] = 0;
    }
    explicit RandomStream( const char* seed1, const char*seed2 ) {
        // xsubi_ is the random number state specified
        // by the drand48 manpage.  Initialize it based
        // on our seed strings:
        unsigned long long h = hash->toUnt( seed1, seed2 );
        xsubi_[0] = (h >> 0*8*sizeof(unsigned short int)) & ~(unsigned short int)0; 
        xsubi_[1] = (h >> 1*8*sizeof(unsigned short int)) & ~(unsigned short int)0; 
        xsubi_[2] = (h >> 1*8*sizeof(unsigned short int)) & ~(unsigned short int)0; 
    }

    double next( void );

  private:
    unsigned short int xsubi_[3];
};

#endif /* RANDOMSTREAM_H */
