#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include "RelativePoint.h"

RelativePoint::RelativePoint( void ) {
    surface_ = 0;
    rst_ = Rst( 1.0, 1.0, 1.0 );
    cached_value_valid_ = 0;
};

RelativePoint::RelativePoint( Surface* surface, Rst rst ) {
    surface_ = surface;
    rst_ = rst;
    cached_value_valid_ = 0;
};

 Xyzw
RelativePoint::value( void ) {
    // This is a huge performance win with
    // multiple layers -- drops us to linear time:
    if(!cached_value_valid_) {
        cached_value_valid_ = 1;
        cached_value_ = surface_->xyzw( rst_ );
    }

    return cached_value_;
};

void RelativePoint::rst( Rst rst ) {  rst_ = rst; cached_value_valid_ = 0; };
Rst RelativePoint::rst( void ) {  return rst_; };


Surface* RelativePoint::surface( void ) { return surface_; }
void RelativePoint::surface( Surface* surface ) { surface_ = surface; }

 void
RelativePoint::saveState( FILE* fd, char* title ) {
    fprintf( fd, "%s.r=%g\n",title,rst_.r());
    fprintf( fd, "%s.s=%g\n",title,rst_.s());
    fprintf( fd, "%s.t=%g\n",title,rst_.t());
}

 void
RelativePoint::loadState( FILE* fd, char* title ) {
    char input[ 1024 ];
    char buf[ 1024 ]; int len;

    // Read a triple of lines looking like:
    // Layer0.13.r=-0.101671
    // Layer0.13.s=0
    // Layer0.13.t=1

    fgets( input, 1024, fd );
    assert(strlen(input)<1023);
    sprintf(buf, "%s.r=", title );
    len=strlen( buf );
    assert( len<1024 );
    assert( !strncmp(input, buf, len ) );
    rst_.r( atof( input+len ) );

    fgets( input, 1024, fd );
    assert(strlen(input)<1023);
    sprintf(buf, "%s.s=", title );
    len=strlen( buf );
    assert( len<1024 );
    assert( !strncmp(input, buf, len ) );
    rst_.s( atof( input+len ) );

    fgets( input, 1024, fd );
    assert(strlen(input)<1023);
    sprintf(buf, "%s.t=", title );
    len=strlen( buf );
    assert( len<1024 );
    assert( !strncmp(input, buf, len ) );
    rst_.t( atof( input+len ) );
}



