#ifndef RELATIVEPOINT_H
#define RELATIVEPOINT_H

#include "Xyzw.h"
#include "Point.h"
#include "Rst.h"
#include "St.h"
#include "CubicPatch.h"

/* This is point defined parametrically */
/* relative to some Surface:            */
class RelativePoint: public Point {

  public:
    RelativePoint( void );
    RelativePoint( Surface* surface, Rst rst );

    St st( void );
    void st( St st );

    // Our coordinate relative
    // to our reference surface.
    // 'r' is our radial displacement,
    // 's' and 't' are in reference
    // surface coordinate system:
    Rst rst( void );
    void rst( Rst rst );

    // Get and set our reference surface:
    Surface* surface( void );
    void surface( Surface* surface );

    virtual Xyzw value( void );
    virtual void saveState( FILE* fd, char*title );
    virtual void loadState( FILE* fd, char*title );

  private:
    Surface* surface_; 
    Rst rst_; 
    bool cached_value_valid_;
    Xyzw cached_value_; 
};

#endif /* RELATIVEPOINT_H */
