#ifndef RGBA_H
#define RGBA_H

#include <stdio.h>

/* This is our main type for passing actual */
/* point values around.  We always pass it  */
/* by value, not by reference:              */

class Rgba {

  public:
    explicit Rgba(): r_(1.0), g_(0.0), b_(0.0), a_(1.0) {}
    explicit Rgba( double r, double g, double b ): r_(r), g_(g), b_(b), a_(1.0) {}
    explicit Rgba( double r, double g, double b, double a ): r_(r), g_(g), b_(b), a_(a) {}

    inline bool operator ==( Rgba const & ) const; // Equality

    inline double r();
    inline double g();
    inline double b();
    inline double a();

    void print(void);
    void println(void);

  private:
    double r_;
    double g_;
    double b_;
    double a_;
};


 inline bool
Rgba::operator ==( Rgba const & o ) const {
    return 
        r_ == o.r_ &&
        g_ == o.g_ &&
        b_ == o.b_ &&
        a_ == o.a_;
}

inline double Rgba::r(void) { return r_; }
inline double Rgba::g(void) { return g_; }
inline double Rgba::b(void) { return b_; }
inline double Rgba::a(void) { return a_; }

#endif /* RGBA_H */
