#ifndef RST_H
#define RST_H

/* A type for representing s,t coord pairs. */
/* We always pass it by value, not by ref:  */

class Rst {

  public:
    explicit Rst( void ): r_(1.0), s_(1.0), t_(1.0) {}
    explicit Rst( double r, double s, double t ): r_(r), s_(s), t_(t) {}

    inline double r();
    inline double s();
    inline double t();

    inline void r( double r );
    inline void s( double s );
    inline void t( double t );

    void print(void);
    void println(void);

  private:
    double r_;
    double s_;
    double t_;
};

inline double Rst::r(void) { return r_; }
inline double Rst::s(void) { return s_; }
inline double Rst::t(void) { return t_; }

inline void Rst::r(double r) { r_ = r; }
inline void Rst::s(double s) { s_ = s; }
inline void Rst::t(double t) { t_ = t; }

#endif /* RST_H */
