
#include "SphereSurface.h"
#include <stdio.h>
#include <math.h>
#include "pi.h"

#include "round_almost_zero_to_zero.h"

SphereSurface::SphereSurface( double x, double y, double z ) {
    x_ = x;
    y_ = y;
    z_ = z;
}

  Xyzw
SphereSurface::point(
    double r,
    double s,
    double t
) {
    double cs = round_almost_zero_to_zero( cos( 2.0 * PI * (1-s) ) );
    double ss = round_almost_zero_to_zero( sin( 2.0 * PI * (1-s) ) );

    double ct = round_almost_zero_to_zero( cos( 1.0 * PI * (1-t) ) );
    double st = round_almost_zero_to_zero( sin( 1.0 * PI * (1-t) ) );

    double x  = (r+x_) * cs * st;
    double y  = (r+y_) * ss * st;
    double z  = (r+z_) *      ct;

    return Xyzw( x, y, z );
}

 Xyzw 
SphereSurface::xyzw( St st ) {
    return this->point( 1.0, st.s(), st.t() );
}

 Xyzw 
SphereSurface::xyzw( Rst rst ) {
    return this->point( rst.r(), rst.s(), rst.t() );
}

