#include "glob.h"
#include "Rgba.h"
#include "SurfaceShader.h"

#define DEFAULT_TEXT   "Surface \"plastic\"\n"


#define DEFAULT_COLOR   Rgba( 1.0, 1.0, 1.0, 1.0 )
#define DEFAULT_COLORB  Rgba( 0.0, 1.0, 0.0, 1.0 )

SurfaceShader::SurfaceShader( void ) {
    text_   = DEFAULT_TEXT;
    color_  = DEFAULT_COLOR;
    colorB_ = DEFAULT_COLORB;
}

SurfaceShader::SurfaceShader( char* text ) {
    text_   = text;
    color_  = DEFAULT_COLOR;
    colorB_ = DEFAULT_COLORB;
}

SurfaceShader::SurfaceShader( Rgba rgba ) {
    text_   = DEFAULT_TEXT;
    color_  = rgba;
    colorB_ = rgba;
}

SurfaceShader::SurfaceShader( char* text, Rgba rgba ) {
    text_   = text;
    color_  = rgba;
    colorB_ = rgba;
}

SurfaceShader::SurfaceShader( char* text, Rgba rgba, Rgba rgbaB ) {
    text_   = text;
    color_  = rgba;
    colorB_ = rgbaB;
}


 void
SurfaceShader::rib( FILE* fd ) {
    Rgba color = parity_ && chequer_all_surfaces ? colorB_ : color_;
    fprintf( fd, text_ );
    if (color.a() != 0.0) {
        fprintf( fd, "Color  [ %g %g %g ]\n", color.r(), color.g(), color.b() );
    }
}

 Rgba
SurfaceShader::color( void ) {
   return color_;
}

 void
SurfaceShader::color( Rgba rgba ) {
    color_ = rgba;
}

 Rgba
SurfaceShader::colorB( void ) {
   return colorB_;
}

 void
SurfaceShader::colorB( Rgba rgba ) {
    colorB_ = rgba;
}

 char* 
SurfaceShader::text( void ) {
   return text_;
}

 void
SurfaceShader::text( char* text ) {
   text_ = text;
}

 int
SurfaceShader::parity( void ) {
    return parity_;
}

 void
SurfaceShader::parity( int parity ) {
    parity_ = parity;
}
