#ifndef SURFACESHADER_H
#define SURFACESHADER_H

#include "Shader.h"
#include "Rgba.h"

/* Object describing how a surface should be   */
/* drawn -- plastic vs metal shader, color &tc */
class SurfaceShader: public Shader {

public:
    SurfaceShader( void );
    SurfaceShader( Rgba rgba );
    SurfaceShader( char* text );
    SurfaceShader( char* text, Rgba rgba );
    SurfaceShader( char* text, Rgba rgba, Rgba rgbaB );

    Rgba color( void );
    void color( Rgba rgba );

    Rgba colorB( void );
    void colorB( Rgba rgba );

    char* text( void );
    void text( char* text );

    int parity( void );
    virtual void parity( int parity );

    virtual void rib( FILE* fd );

private:
    char* text_; 
    Rgba  color_; 
    Rgba  colorB_; 
    int   parity_;
};

#endif /* PATCHSURFACE_H */
