#include "Xyzw.h"
#include <stdio.h>
#include <math.h>

 void
Xyzw::print( void ) const {
    double x = x_;
    double y = y_;
    double z = z_;
    double w = w_;
    if( w != 0.0  && w != 1.0) {
        x /= w;
        y /= w;
        z /= w;
        w  = 1.0;
    }
    printf("%g %g %g", x, y, z );
    if (w == 0.0) printf(" %g", w );
}

 void
Xyzw::println( void ) const {
    this->print();
    printf("\n");
}

 const Xyzw
Xyzw::normalize( void ) const {
    double len = this->length();
    if ( len != 0.0) {
        double inv = 1/len;
        return Xyzw( x_*inv, y_*inv, z_*inv, w_ );
    }
    return *this;
}

 double
Xyzw::length( void ) const {
    return sqrt( x_*x_ + y_*y_ + z_*z_ );
}

